unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
     modes:array[0..255] of TDevMode;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
 i: Integer;
begin
 ListBox1.Items.Clear;
 i := 0;
 while EnumDisplaySettings(nil, i, Modes[i]) do
  begin
   ListBox1.Items.Add(IntToStr(Modes[i].dmBitsPerPel)+' '+IntToStr(Modes[i].dmPelsWidth)+' '+
                     IntToStr(Modes[i].dmPelsHeight)+'   '+IntToStr(Modes[i].dmDisplayFrequency));
   Inc(i);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Modes[ListBox1.ItemIndex].dmFields := DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or DM_DISPLAYFLAGS or DM_DISPLAYFREQUENCY;
 ChangeDisplaySettings(Modes[ListBox1.ItemIndex], CDS_UPDATEREGISTRY);
end;

end.
